import java.lang.*;
import java.util.*;

public abstract class h extends java.lang.Object
{
    public static boolean compatible( String s1, String s2 )
    {
        String head = getHead( s2 );
        if( head.equals( "" ) ) return true;
        if( ( indexOf( s1, negate( head ) ) ) != -1 ) return false;
        return compatible( s1, getTail( s2 ) );
    }

    public static String union( String s1, String s2 )
    {
        String result;
        if( s1.equals( "[]" ) ) return result = new String( s2 );
        String head = getHead( s2 );
        if( head.equals( "" ) ) return result = new String( s1 );
        if( indexOf( s1, head ) == -1 )
            return union( s1.substring( 0, s1.length()-1 ) + "," + head + "]", getTail( s2 ) );
        else
            return union( s1, getTail( s2 ) );
    }

    public static String getHead( String s )
    {
        String result;
        if( !s.substring( 0, 1 ).equals( "[" ) ) return null; // da togliere
        if( s.equals( "[]" ) ) return result = new String( "" );
        int right = s.indexOf( ',' );
        if( right == -1 ) right = s.indexOf( ']' );
        return result = new String( s.substring( 1, right ).trim() );
    }

    public static String getTail( String s )
    {
        String result;
        if( !s.substring( 0, 1 ).equals( "[" ) ) return null; // da togliere
        if( s.equals( "[]" ) ) return result = new String( s );
        int left = s.indexOf( ',' ) + 1;
        if( left == 0 ) left = s.indexOf( ']' );
        return result = new String( "[" + s.substring( left ) );
    }

    private static String negate( String s )
    {
        String result;
        if( s.substring( 0, 1 ).equals( "[" ) ) return null; // da togliere
        if( s.length() < 4 ) return result = new String( "not " + s );
        else if( s.substring( 0, 4 ).equals( "not " ) ) return result = new String( s.substring( 4 ) );
        return result = new String( "not " + s );
    }

    private static int indexOf( String str, String sub ) {
        int left = str.indexOf( sub ), right = left + sub.length();
        if( ( left > -1 )&&( str.length() > right ) ) {
             String ch = str.substring( right, right+1 );
            if( !( ch.equals( "]" ) ) && !( ch.equals( "," ) ) )
            {
                int left1 = indexOf( str.substring( right, str.length() ), sub );
                if( left1 > -1 ) left = left1 + right;
                else left = -1;
            }
        }
        return left;
    }
    
    // trasforma "[a,not b]" in "a,not(b)"
    public static String vectorToGoal( String v ) {
        if( v.equals( "[]" ) ) return new String( "" );
        String tail = getTail( v ), separator;
        if( tail.equals( "[]" ) ) separator = new String( "" ); else separator = new String( "," );
        String head = getHead( v );
        if( ( head.length()>3 )&&( head.substring( 0, 4 ).equals( "not " ) ) )
            return new String( "not(" + head.substring( 4, head.length() ) + ")" + separator + vectorToGoal( tail ) );
        else
            return new String( head + separator + vectorToGoal( tail ) );
    }
    
    // differenza insiemistica, tra due stringhe del tipo [a,b,not c,d,not e];
    // tolgo da s1 gli elementi dell'intersezione tra s1 e s2.
    public static String difference( String s1, String s2 ) {
        if( s1.equals( "[]" ) ) return new String( s1 );
        String head = getHead( s1 ), tail = getTail( s1 );
        int left = indexOf( s2, head );
        String diff = difference( tail, s2 );
        if( left != -1 )
            return diff;
        else {
            String separator;
            if( diff.equals( "[]" ) )
                separator = new String( "" );
            else
                separator = new String( "," );
            return new String( "[" + head + separator + diff.substring( 1, diff.length()-1 ) + "]" );
        }
    }
    
    // [X0, X1, ...] viene trasformato nel vettore V0 = X0; V1 = X1; ...
    // Xi nella forma [a1, a2, ...], 
    // ai ::= <abd> | not <abd>
    // es.: stringToVector( "[[a],[b,not c]]" ) ==> V; V0==[a]; V1==[b,not c].
    public static Vector stringToVector( String s ) {
        if( ( !s.startsWith( "[" ) )|| (!s.endsWith( "]" ) ) ) return null;
        Vector v = new Vector();
        if( s.equals( "[]" ) ) return v;
        String list = s.substring( 1, s.length()-1 );
        int left = 0, right = s.indexOf( "]" );
        boolean stringNotCompletelyParsed = true;
        do {
            String element = new String( list.substring( left, right ) );
            v.addElement( ( String )element );
            if( right < list.length() ) {
                String tail = list.substring( right, list.length() );
                left = right + tail.indexOf( "[" ); right += tail.indexOf( "]" ) + 1;
            }
            else stringNotCompletelyParsed = false;
        } while( stringNotCompletelyParsed );
        return v;
    }
    
    // Il vettore V0 = X0; V1 = X1; ... viene trasformato in ( String ) "[X0, X1, ...]"
    // Xi nella forma [a1, a2, ...], 
    // ai ::= <abd> | not <abd>
    // es.: vectorToString( V ) ==> "[[a],[b,not c]]"; V0==[a]; V1==[b,not c].
    public static String vectorToString( Vector v ) {
        if( v==null ) return null;
        return v.toString();
    }
    
    // true se [X1, X2, ...] contiene Y, con 
    // Xi, Y nella forma [a1, a2, ...], 
    // ai ::= <abd> | not <abd>
    // es.: ASSERT( contains( "[[a],[b,not c]]", "[not c,b]" ) )
    // ASSERT( !contains( "[[a],[b,c]]", "[not c,b]" ) )
    public static boolean contains( String listAbdOut, String delta0 ) {
//        if( delta0.equals( "[]" ) ) return true; // NO.
        String delta1 = getHeadList( listAbdOut );
        if( delta1.equals( "" ) ) return false;
        if( difference( delta0, delta1 ).equals( difference( delta1, delta0 ) ) )
            return true; // ( A-B == B-A ) <=> A == B
        else
            return contains( getTailList( listAbdOut ), delta0 );
    }
    
    // ASSERT( getHeadList( "[[a],[b,c]]" ).equals( "[a]" ) )
    public static String getHeadList( String list )
    {
        String result;
        if( ( !list.startsWith( "[" ) )||( !list.endsWith( "]" ) ) ) return null; // da togliere
        if( list.equals( "[]" ) ) return result = new String( "" );
        String s = list.substring( 1, list.length()-1 );
        int right = s.indexOf( ']' );
        return result = new String( s.substring( 0, right + 1 ).trim() );
   }
    
    // ASSERT( getTailList( "[[a],[b,c]]" ).equals( "[[b,c]]" ) )
    public static String getTailList( String list )
    {
        String result;
        if( ( !list.startsWith( "[" ) )||( !list.endsWith( "]" ) ) ) return null; // da togliere
        if( list.equals( "[]" ) ) return result = new String( list );
        String s = list.substring( 1, list.length()-1 );
        int left = s.indexOf( ']' ) + 1;
        int comma = s.substring( left ).indexOf( ',' ) + 1;
        if( comma==0 ) return result = new String( "[]" );
        return result = new String( "[" + s.substring( comma + left ).trim() + "]" );
    }
    
    public static String nz( String s, String n )
    {
        if( s==null ) {
            String result = new String( n );
            return result;
        }
        else return s;
    }

    public static void main( String args[] ) {
        String s1 = "[q]";
        String s2 = "[not b]";
        String s3 = "[a,not b,c]";
        String s4 = "[a,not b,not c,d]";
        System.out.println( "vectorToGoal: " + s1 + " --> " + vectorToGoal( s1 ) );
        System.out.println( "vectorToGoal: " + s2 + " --> " + vectorToGoal( s2 ) );
        System.out.println( "compatible( " + s1 + ", " + s2 + " )==" + compatible( s1, s2 ) );
        System.out.println( "compatible( " + s3 + ", " + s4 + " )==" + compatible( s3, s4 ) );
        System.out.println( "union( " + s1 + ", " + s2 + " )==" + union( s1, s2 ) );
        System.out.println( "union( " + s1 + ", " + s4 + " )==" + union( s1, s4 ) );
        System.out.println( "difference( " + s1 + ", " + s2 + " )==" + difference( s1, s2 ) );
        System.out.println( "difference( " + s4 + ", " + s2 + " )==" + difference( s4, s2 ) );
        String s_list = new String( "[" + s1 + "," + s2 + "," + s3 + "," + s4 + "]" );
        Vector v=null;
        System.out.println( "stringToVector( " + s_list + " ) --> " + ( v=stringToVector( s_list ) ) );
        System.out.println( "vectorToString( stringToVector( " + s_list + " ) ) --> " + vectorToString( stringToVector( s_list ) ) );
        System.out.println( "stringToVector( vectorToString( " + v + " ) ) --> " + stringToVector( vectorToString( v ) ) );
        System.out.println( "getHeadList( " + s_list + " ) --> " + getHeadList( s_list ) );
        System.out.println( "getTailList( " + s_list + " ) --> " + getTailList( s_list ) );
        System.out.println( "getHeadList( [" + s1 + "] ) --> " + getHeadList( "[" + s1 + "]" ) );
        System.out.println( "getTailList( [" + s1 + "] ) --> " + getTailList( "[" + s1 + "]" ) );
        System.out.println( "getHeadList( [] ) --> " + getHeadList( "[]" ) );
        System.out.println( "getTailList( [] ) --> " + getTailList( "[]" ) );
        System.out.println( "getHeadList( [[]] ) --> " + getHeadList( "[[]]" ) );
        System.out.println( "getTailList( [[]] ) --> " + getTailList( "[[]]" ) );
        System.out.println( "contains( " + s_list + ", " + s4 + " )==" + contains( s_list, s4 ) );
        String s_list_short = new String( "[" + s1 + "," + s4 + "]" );
        System.out.println( "contains( " + s_list_short + "," + s3 + " )==" + contains( s_list_short, s3 ) );
        String s5 = "[not b,not c,a,d]";
        System.out.println( "contains( " + s_list_short + ", " + s5 + " )==" + contains( s_list_short, s5 ) );
        System.out.println( "contains( " + s_list_short + ", [] )==" + contains( s_list_short, "[]" ) );
        System.out.println( "contains( [" + s5 + "], " + s5 + " )==" + contains( "[" + s5 + "]", s5 ) );
        System.out.println( "contains( [" + s1 + "], " + s1 + " )==" + contains( "[" + s1 + "]", s1 ) );
        System.out.println( "stringToVector( " + s5 + " ) --> " + ( v=stringToVector( s5 ) ) );
    }
}