// un agentServer istanzia un thread di tipo login per entrare nel bunch o
// per uscire dal bunch (parametro inout)
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import java.util.*;
import java.lang.*;
import amzi.ls.*;

public class loginThread extends java.lang.Thread
{
//    Vector others;
    int port;
    iBlackboard b;
    iAgent as;
    String name, address;
    String delta0=null, abducibles;
    boolean inout, result=false;
    
    public loginThread( iAgent as, iBlackboard b, String name, String address, int port )
    {
        inout = true;
        this.as = as;
        this.b = b;
        this.name = name;
        this.address = address;
        this.port = port;
        this.delta0 = new String( "[]" );
    }
    
    public loginThread( iAgent as, iBlackboard b, String name, String address, int port, String delta0 )
    {
        inout = true;
        this.as = as;
        this.b = b;
        this.name = name;
        this.address = address;
        this.port = port;
        this.delta0 = delta0;
    }
    
    public loginThread( iBlackboard b, String name )
    {
        inout = false;
        this.b = b;
        this.name = name;
    }
    
    public void run()
    {
        if( inout ) 
        {
            System.out.println( "Thread starting login..." );
            login();
            System.out.println( "...Thread ended login" );
        }
        else 
        {
            System.out.println( "Thread starting logout..." );
            result = logout();
            System.out.println( "...Thread ended logout" );
        }
    }
    
    public int login()
    {
        result = false;
        int howMany = 0;
        String listAbdOut;
        String delta_delta0_delta1_delta2 = null;
        System.out.println( "Il delta locale a " + name + " vale " + delta0 );
        System.out.println( "La lista di abducibili dell'agente  supposta coincidere con quella del bunch" );
        System.out.println( "Fase uno: verifica della consistenza del delta della blackboard con la KB dell'agente" );
        System.out.println( "1) Si blocca la blackboard, e bisognerebbe attendere la fine delle computazioni (ma per ora questo controllo non  implementato)" );
        String delta = null;
        try {
            delta = b.requestLogin( name, address, port );
        } catch ( RemoteException e ) { 
            e.printStackTrace(); 
            return howMany; 
        }
        System.out.println( "1) Il delta che ho ottenuto dalla blackboard vale " + delta );
        if( !h.compatible( delta, delta0 ) ) {
            System.out.println( "2) + 3) " + name + " non pu entrare a far parte del bunch perch delta0  incompatibile con delta." );
            result = false;
            try {
                b.unlockLogin();
            } catch ( RemoteException e ) { 
                e.printStackTrace(); 
                return howMany; 
            }
            return howMany;
        }
        listAbdOut = localSolveAll( delta, delta0 );
        System.out.println( "localSolveAll( " + delta + ", " + delta0 + " ) ha restituito " + listAbdOut );
        if( listAbdOut != null )
        {
            if( listAbdOut.equals( "[]" ) ) {
                System.out.println( "3) L'agente non pu entrare a far parte del bunch perch la localSolveAll non ha restituito valori ammissibili" );
                result = false;
                try {
                    b.unlockLogin();
                } catch ( RemoteException e ) { 
                    e.printStackTrace(); 
                    return howMany; 
                }
                return howMany;
            }
            else try {
                if( h.contains( listAbdOut, h.nz( delta, "[]" ) ) ) {
                    System.out.println( "4) L'agente pu entrare a far parte del bunch perch listAbdOut contiene tra i valori anche " + delta );
                    ( ( agentServer )as ).others = b.getIn( name, address, port );
                    result = true;
                    howMany = ( ( agentServer )as ).others.size();
                }
                else {
                    System.out.println( "Fase due: negoziazione di " + listAbdOut + " col bunch..." );
                    System.out.println( "5) " + name + " entra temporaneamente nel bunch" );
                    ( ( agentServer )as ).setOthers( b.tempLogin( name, address, port ) );
                    ( ( agentServer )as ).loggedIn = true;
                    boolean confirmed = false;
                    try {
                        logicAgent la = new logicAgent( ( agentServer )as );
                        while( ( !listAbdOut.equals( "[]" ) )&&( !confirmed ) )
                        {
                            String delta0_delta1 = h.difference( h.getHeadList( listAbdOut ), delta );
                            System.out.println( "6) + 7) Provo la consistenza di " + delta0_delta1 + ", con delta = " + delta );
                            delta_delta0_delta1_delta2 = la.solveAbducible( true, delta0_delta1.substring( 1, delta0_delta1.length()-1 ) );
                            if( delta_delta0_delta1_delta2 != null ) {
                                System.out.println( "8) Trovato " + delta_delta0_delta1_delta2 );
                                System.out.println( "8) as.blackboard.write( " + delta_delta0_delta1_delta2 + " )" );
                                b.write( delta_delta0_delta1_delta2 );
                                confirmed = true;
                            }
                            else
                                System.out.println( "6) " + delta0_delta1 + " non va bene: provo con un altro delta0_delta1" );
                                listAbdOut = h.getTailList( listAbdOut );
                        }
                        la.close();
                    } catch ( LSException e ) { System.out.println( "@@@ " + e.GetMsg() ); }
                    if( confirmed ) {
                        System.out.println( "8) " + name + " viene confermato parte del bunch" );
                        b.confirmLogin( name );
                        result = true;
                    }
                    else {
                        System.out.println( "9) listAbdOut non ha valori accettabili: " + name + " non pu entrare a far parte del bunch" );
                        ( ( agentServer )as ).loggedIn = false;
                        b.rejectLogin( name );
                        ( ( agentServer )as ).others = null;
                    }
                }
            } catch ( RemoteException re ) {
                re.printStackTrace();
                System.out.println( "Errore nella RMI in fase di login" );
            }
            if ( ( ( agentServer )as ).others==null ) {
                if( result==true ) System.out.println( "Per ora sono l'unico agente" );
            }
            else {
                System.out.println( "Ho ottenuto la lista di agenti: " + ( ( agentServer )as ).others.toString() );
                howMany = ( ( agentServer )as ).others.size();
            }
        }
        else {
            System.out.println( "C' stato un errore nella chiamata al Prolog: localSolveAll() ha restituito 'null'." );
            System.out.println( "L'agente non e` stato inserito nel bunch" );
            ( ( agentServer )as ).loggedIn = false;
            try {
                b.unlockLogin();
                // result = false;
            } catch ( RemoteException re ) {
                re.printStackTrace();
                System.out.println( "Errore nella RMI in fase di login" );
            }
        }
        return howMany;
    }
    
    public boolean logout()
    {
        boolean gotOut=false;
        try {
            gotOut = b.getOut( name );
        } catch ( RemoteException re ) {
            re.printStackTrace();
            System.out.println( "Errore nella RMI in fase di logout" );
        }
        return gotOut;
    }
    
    public boolean getResult()
    {
        return result;
    }
    
    private String consistent() {
        String goal=null;
        try {
            goal = b.read();
            b.unlock(); // per non lasciare la blackboard bloccata
        } catch ( RemoteException e ) { e.printStackTrace(); return null; }
        if( goal.equals( "[]" ) ) return new String( goal );
        try {
            logicAgent la = new logicAgent( ( agentServer )as );
            String risultato = la.consistent( h.vectorToGoal( goal ) );
            if( risultato != null ) {
                System.out.println( "I vincoli dell'agente sono compatibili col delta esistente" );
                String diff = h.difference( risultato, goal );
                if( !diff.equals( "[]" ) )
                    System.out.println( "Al delta esistente deve essere aggiunto " + diff );
                la.close();
                if( b.write( risultato ) ) return diff;
                else return null;
            } else {
                System.out.println( "Local constraints not compatible with actual delta" );
                la.close();
                return risultato;
            }
        } catch ( LSException e ) { System.out.println( "@@@ " + e.GetMsg() ); }
          catch ( RemoteException e1 ) { System.out.println( "@@@ Exception occurred at login while attempting to update delta" ); }
        return null;
    }

    // nuova versione (usa setof e delta!=[])
    private Vector consistent( String delta ) {
        String goal=null;
        try {
            goal = b.read();
            b.unlock(); // per non lasciare la blackboard bloccata
        } catch ( RemoteException e ) { e.printStackTrace(); return null; }
        if( goal.equals( "[]" ) ) {
            Vector empty = new Vector( 1 );
            empty.addElement( new String( goal ) );
            return empty;
        }
        try {
            logicAgent la = new logicAgent( ( agentServer )as );
            Vector setof_risultato = la.setof_consistent( h.vectorToGoal( goal ), delta );
            if( setof_risultato != null ) {
                System.out.println( "I vincoli dell'agente sono compatibili col delta esistente. I risultati ottenuti sono:\n" + setof_risultato );
                Vector setof_delta1=null;
                for (Enumeration e = setof_risultato.elements() ; e.hasMoreElements() ;) {
                    String risultato = ( String )e.nextElement();
                    String delta1 = h.difference( risultato, goal );
                    setof_delta1 = new Vector( setof_risultato.size() );
                    if( !delta1.equals( "[]" ) ) {
                        System.out.println( "Possibile delta1: " + delta1 );
                        setof_delta1.addElement( ( String )delta1 );
                    }
                }
                la.close();
                return setof_delta1;
            } else {
                System.out.println( "Local constraints not compatible with actual delta" );
                la.close();
                return null;
            }
        } catch ( LSException e ) { System.out.println( "@@@ " + e.GetMsg() ); }
        return null;
    }
    
    // local_solve_all( delta U delta0, [], ListAbdOut )
    // risultato: una String che rappresenta una lista di liste (ListAbdOut), oppure
    // null nel caso che la chiamata al Prolog abbia funzionato male
    // listAbdOut  della forma: [[delta U delta0 U delta1],[delta U delta0 U delta1'],...]
    private String localSolveAll( String delta, String delta0 ) {
        String listAbdOut = null;
        String goal = h.union( h.nz( delta, "[]" ), h.nz( delta0, "[]" ) );
        if( goal.equals( "[]" ) ) {
            String empty = new String( "[[]]" );
            return empty;
        }
        Vector setof_risultato=null;
        try {
            logicAgent la = new logicAgent( ( agentServer )as );
            setof_risultato = la.setof_consistent( h.vectorToGoal( goal ), "[]" );
            la.close();
        } catch ( LSException e ) { System.out.println( "@@@ " + e.GetMsg() ); }
        listAbdOut = h.vectorToString( setof_risultato );
        return listAbdOut;
    }
}