import java.lang.*;
import java.util.Vector;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import amzi.ls.*;

public class solveAbducibleThread extends java.lang.Thread
{
    logicAgent agent;
    String result = null;
    String delta = null;
    String goal = null;
    long term;

    public solveAbducibleThread( logicAgent a, String g, String abd ) {
        agent = ( logicAgent )a;
        goal = g;
        delta = abd;
        agent.as.printMessage( "costruttore di solveAbducibleThread( " + g + ", " + abd + " ) per " + getName() + ", in " + getThreadGroup().getName() );
    }

    public void run()
    {
        agent.as.printMessage( "solveAbducibleThread " + getName() + ": run()" );
        long risultato;
        term = 0;
        try {
            // Caricamento metainterprete
            long s = agent.ls.ExecStr("load([startabducible])");
            // Esecuzione query
            term = agent.ls.ExecStr( "start_abductive_derivation([" + goal + "]," + delta + ",AbdOut)" );
            // true --> term>0, false --> term=0
            if( term != 0 ) {
                risultato = agent.ls.GetArg( term, 3 );   //risultato contiene la lista degli abducibili trovati
                result = agent.ls.TermToStr( risultato, 10000 );
                agent.as.blackboard.write( result );
                agent.as.printMessage( "logicAgent " + agent.instanceID + " di " + agent.as.my.name + ": agent.as.blackboard.write( " + result + " )" );
            }
            else {
                agent.as.blackboard.write( delta );
                agent.as.printMessage( "logicAgent " + agent.instanceID + " di " + agent.as.my.name + ": agent.as.blackboard.write( " + delta + " )" );
            }
        } catch ( Exception e ) { e.printStackTrace(); }
    }

    public long getResult() {
        return term;
    }
}